// GRAVER 1.0 Demonstration file for POV-Ray 2.n
// Illustrates several applications of Graver output files as height fields
// and bump maps.
// Richard LeVitt, CIS 76216,2066, March 1994
//
//Requires HELLO.GIF, GROOVES.GIF, and CURVES.GIF  

#include "colors.inc"
#include "textures.inc"
#include "stones.inc"

// WORLD ******************************************************************
camera {
   location  <-0, 3,-14>
   direction <0, 0,  1.5>
   up        <0, 1,  0>
   right   <4/3, 0,  0>
   look_at   <0, 3.01, 0>
}

light_source {<20, 20, -30> color White}

//TEXTURES ****************************************************************

#declare BlueStone =   //Adapted from Mike Miller's Stone23 
texture{Grnt29 scale <1, 1, 2> rotate <40, 0, 0> rotate <0, 0, 30>}
texture{Grnt24a scale <2, 1, 2> rotate <40, 0, 0> rotate <0, 0, 30>}
texture{Crack1 scale <1, 2, 1.5> rotate <0, 0, 40>}
texture{pigment{color Blue filter 0.8}
        finish{phong 1.0 phong_size 90}  
       }

// OBJECTS ****************************************************************
plane { -z, 0
   pigment {Gold}
   finish {diffuse 0.7 specular .4 roughness .1}
   normal {
      bump_map {
         gif "curves.gif" 
         bump_size 8
         interpolate 2
      }
      scale 1.2 
   }  
}

object{  //box with engraved letters
  intersection{
    box {
      <-4, 0,-1>, //near lower left corner
      <4, 6, 2> //far upper right corner
      texture{
        BlueStone
      } 
    }
    height_field { 
      gif "hello.gif" 
      translate <-.5, 0, 0>
      scale <8, .2, 6>
      rotate <-90, 0, 0>
      translate <0, 0,-.817>      
      pigment {Gold}
      finish {diffuse 0.8 specular .7 roughness .1}
      smooth
    }
  }
}

sphere {
  <0, 0, 0>, .75  
    pigment {SeaGreen}
    finish {diffuse 0.8 specular .6 roughness .1}
    normal {
      bump_map {
         gif "grooves.gif"  
         bump_size 10
         interpolate 2
         map_type 1    
      }   
    }
    translate <-3.4, 5.5, -2.5>
}

cylinder {
  <0, 0, 0>,       
  <0, .50, 0>, 1        
  pigment {Maroon}
  finish {diffuse 0.6 ambient .2 specular .6 roughness .1}
  normal {
    bump_map {
      gif "grooves.gif"  
      bump_size 10
      interpolate 2
      map_type 1    
    }   
  }
  rotate < -80, -15, -30>
  translate < 3.5, 5.5,-1.2>
}
cone {
  <0, 0, 0>,  .8     
  <0, 2.5, 0>, .25        
  pigment {MediumAquamarine}
  finish {diffuse 0.8 ambient .2 specular .6 roughness .1}
  normal {
    bump_map {
      gif "grooves.gif"  
      bump_size 10
      interpolate 2
      map_type 2    
    }   
  }
  translate < 2.8, 1.3, -2.5>
  rotate < 0, 0, -30>
  rotate < 15, 0, 0>
}

height_field { 
      gif "curves.gif" 
      translate <-.5, -.5, -.5>
      scale 1.7
      rotate <-45, 45, -30>
      translate <-3, 1, -3>      
      texture {
        pigment {NeonPink filter .5}
        finish {diffuse 0.9 specular .5 roughness .1 }     
      }
      smooth
}